<?php 

 /*
Plugin Name: ApexChat Invitation
Plugin URI: http://www.apexchat.com
Description: Plugin for use with ApexChat
Version: 1.1.0
*/


 add_action( 'admin_menu', 'apex_admin_menu' );
 function apex_admin_menu() {
	// page title, settings menu title, 
    add_options_page( 'ApexChat Options', 'ApexChat', 'manage_options', 'apexchat_plugin', 'apexchat_options_page' );
 }

 function apex_settings_api_init() {
	register_setting( 'apex_settings_group', 'apex_settings_group', 'apex_settings_validate_callback_function');
	
 	// Add the section to reading settings so we can add our
 	// fields to it
 	add_settings_section('apex_setting_section',
		'General',
		'apex_setting_section_callback_function',
		'apexchat_options_page');
 	
 	// Add the field with the names and function to use for our new
 	// settings, put it in our new section
 	add_settings_field('apex_setting_companykey',
		'Company Key',
		'apex_setting_companykey_callback_function',
		'apexchat_options_page',
		'apex_setting_section');
		
	add_settings_field('apex_setting_enabled',
		'Enabled',
		'apex_setting_enabled_callback_function',
		'apexchat_options_page',
		'apex_setting_section');
		
 	
 }// apex_settings_api_init()
 
 add_action('admin_init', 'apex_settings_api_init');
 
 function apexchat_options_page() {
    ?>
    <div class="wrap">
        <h2>ApexChat Options</h2>
        <form action="options.php" method="POST">
            <?php settings_fields( 'apex_settings_group' ); ?>
            <?php do_settings_sections( 'apexchat_options_page' ); ?>
            <?php submit_button(); ?>
        </form>
    </div>
    <?php
 }
 
 function apex_setting_section_callback_function() {
 	echo ''; // describes the general section
 }
 
 function apex_setting_companykey_callback_function() {
	$options = get_option('apex_settings_group');
 	echo '<input name="apex_settings_group[apex_setting_companykey]" id="apex_setting_companykey" type="text" value="' . @$options['apex_setting_companykey'] . '" class="code" /> The company key provided to you by ApexChat';
 }
 
 function apex_setting_enabled_callback_function() {
	$options = get_option('apex_settings_group');
	echo '<input name="apex_settings_group[apex_setting_enabled]" id="apex_setting_enabled" type="checkbox" value="1" ' . checked(@$options['apex_setting_enabled'], true, false) . ' class="code" /> Enable the chat invitation';
 }
 
 function apex_settings_validate_callback_function($input) {
	$input['apex_setting_companykey'] = trim($input['apex_setting_companykey']);
	return $input;
 }
 
 /* actual script used to inject the script tag */
 function apex_insert_function(){
	$options = get_option('apex_settings_group');
	if($options['apex_setting_enabled']){
		wp_enqueue_script('apex', "//www.apex.live/scripts/invitation.ashx?company=" . $options['apex_setting_companykey'], array(), null); 
	}
 }
 
 /* adding async to the invitation script */
 function add_async_to_invitation($tag, $handle){
	 if ('apex' == $handle){
		 return str_replace(' src', ' async src', $tag);
	 }
	 return $tag;
 }

 add_filter('script_loader_tag', 'add_async_to_invitation', 10, 2);
 add_action('wp_enqueue_scripts', 'apex_insert_function');
